// File: ch_string.h
// Define a simple string class suitable for
// using with the Function and Set ADTs.


#ifndef CH_STRING_H
#define CH_STRING_H

#include <cstring>
#include <iostream>

class ch_string
{
  public :
    // Default constructor.
    ch_string() { pointer_ = 0 ; }

    // Convert from an ordinary char string.
    ch_string( char * p) { pointer_ = p ; }

    // ==
    bool operator==( const ch_string &other ) const {
        return strcmp( pointer_, other.pointer_ ) == 0; }
    // !=
    bool operator!=( const ch_string &other ) const {
        return strcmp( pointer_, other.pointer_ ) != 0; }
    // <
    bool operator<( const ch_string &other ) const {
        return strcmp( pointer_, other.pointer_ ) < 0; }
    // <=
    bool operator<=( const ch_string &other ) const {
        return strcmp( pointer_, other.pointer_ ) <= 0; }
    // >
    bool operator>( const ch_string &other ) const {
        return strcmp( pointer_, other.pointer_ ) > 0 ; }
    // >=
    bool operator>=( const ch_string &other ) const {
        return strcmp( pointer_, other.pointer_ ) >= 0; }

    char* to_char_ptr() { return pointer_ ; }

  private:
    char* pointer_ ;
} ;

inline std::ostream& operator<<( std::ostream &out, ch_string str ) {
    out << str.to_char_ptr() ;
    return out ;
}
#endif